package client;

import javax.swing.*;
import java.awt.*;
import java.awt.event.*;
import java.awt.image.*; 
import javax.swing.border.TitledBorder;

/**
 * A ClientFrameAbout is an extended JFrame object which
 *	gives program developpment informations.
 */
public class ClientFrameAbout extends JFrame {		
	private JPanel p;
	private JButton ok;
	
	/**
	 * Construct a new ServerFrameAbout object.
	 */
  public ClientFrameAbout() {
    super("..::  bioECS v1.0  ::  About Window  ::.. ");
   	setIconImage(Toolkit.getDefaultToolkit().getImage("./ico/bioecs.png"));   	
    addWindowListener(new WindowAdapter() {
    	public void windowClosing(WindowEvent e) {
    		dispose();
    	}
    });   
    buildPanel();
		getContentPane().add(p, BorderLayout.CENTER);   
    setSize(550, 600);
    setResizable(false);
    setVisible(true);
  }
  
  /**
   * Build intern panel which contains all the displayed objects.
   */
  private void buildPanel() { 
  	JLabel ulg = new JLabel("", new ImageIcon("./ico/ulg.gif"), 0);
 		JLabel scappl = new JLabel("", new ImageIcon("./ico/scappl.gif"), 0);
 		JLabel cbig = new JLabel("", new ImageIcon("./ico/cbig.gif"), 0);
 		
  	JLabel lab1 = new JLabel(
  		"\nbioECS v1.0  -  Biology Easy Cluster Search");
  	lab1.setFont(new Font("TAHOMA", Font.BOLD, 18));
  	JLabel lab2 = new JLabel(
  		"..::   Client program   ::..");
  	lab2.setFont(new Font("TAHOMA", Font.PLAIN, 16));  
  	JLabel lab3 = new JLabel("\n\n");	
    JLabel lab4 = new JLabel(
    	"created by Benjamin Renwart"); 
    lab4.setFont(new Font("TAHOMA", Font.PLAIN, 14));   
    JLabel lab5 = new JLabel("\n\n");	
  	JLabel lab6 = new JLabel(
  		"Service de Mthodes Stochastiques");
  	lab6.setFont(new Font("TAHOMA", Font.PLAIN, 14));  
  	JLabel lab7 = new JLabel(
  		"(Department of Electrical Engineering and Computer Science)");
  	lab7.setFont(new Font("TAHOMA", Font.PLAIN, 12)); 		
  	JLabel lab8 = new JLabel("\n");	
  	JLabel lab9 = new JLabel(
  		"Service de Biologie Molculaire et Gnie Gntique");
  	lab9.setFont(new Font("TAHOMA", Font.PLAIN, 14));  
  	JLabel lab10 = new JLabel(
  		"(Department of Life Science)");
  	lab10.setFont(new Font("TAHOMA", Font.PLAIN, 12)); 		
  	JLabel lab11 = new JLabel("\n");		
  	JLabel lab12 = new JLabel(
  		"CBIG - Centre of Biomedical Integrative Genoproteomics");
  	lab12.setFont(new Font("TAHOMA", Font.PLAIN, 14));  
  	JLabel lab13 = new JLabel("\n\n");	
    JLabel lab14 = new JLabel(
    	"University of Lige - Ulg - 2004/2005");
 		
 		ok = new JButton("OK");
    ok.addActionListener(new ListOK());
 		
  	p = new JPanel();
  	p.setBackground(Color.WHITE);
  	p.setForeground(Color.darkGray);		
		p.setLayout(new GridBagLayout());
		addComponent(p, ulg, 0, 0, 2, 1);
		addComponent(p, lab1, 0, 1, 2, 1);
		addComponent(p, lab2, 0, 2, 2, 1);
		addComponent(p, lab3, 0, 3, 2, 1);
		addComponent(p, lab4, 0, 4, 2, 1);
		addComponent(p, lab5, 0, 5, 2, 1);
		addComponent(p, lab6, 0, 6, 2, 1); 
		addComponent(p, lab7, 0, 7, 2, 1);
		addComponent(p, lab8, 0, 8, 2, 1);
		addComponent(p, lab9, 0, 9, 2, 1);
		addComponent(p, lab10, 0, 10, 2, 1);
		addComponent(p, lab11, 0, 11, 2, 1); 
		addComponent(p, lab12, 0, 12, 2, 1);
		addComponent(p, lab13, 0, 13, 2, 1);
		addComponent(p, lab14, 0, 14, 2, 1);
		addComponent(p, scappl, 0, 15, 1, 1);
		addComponent(p, cbig, 1, 15, 1, 1);	 
		addComponent(p, ok  , 0, 16, 2, 1);
  }
	
	/**
	 * Set the frame in state visible or invisible, 
	 *	and set frame location on screen according to its current size.
	 * @param b a boolean indicating the frame visibility value
	 */
	public void setVisible(boolean b){
		if (b) {
			Dimension screenSize = Toolkit.getDefaultToolkit().getScreenSize();
		  int screenWidth  = screenSize.width;
		  int screenHeight = screenSize.height;
		  int frameWidth   = getSize().width;
		  int frameHeight  = getSize().height;
		  int posX         = (screenWidth - frameWidth) / 2;
		  int posY         = (screenHeight - frameHeight) / 2;
		  setLocation(posX, posY);
		}
		super.setVisible(b);
	}
	
	/**
	 * Simply add a component to the container passed as argument.
	 *	By default, the component is centered on the destination container. 
	 * @param container the container to update
	 * @param component the component to add
	 * @param x the horizontal position wanted
	 * @param y the vertical position wanted
	 * @param width the number of place to take in width
	 * @param height the number of place to take in height
	 */
	private void addComponent(Container container, Component component, 
		  																	int x, int y, int width, int height) {
		addWithConstrains(container, component, x, y, width, height);
	}
	
	/**
	 * Manage simply the layout to add component in the container. 
	 * Create a GridBagConstraints to add simply and more precisely components.
	 *	By default, the component is centered on the destination container. 
	 * @param container the container to update
	 * @param component the component to add
	 * @param x the horizontal position wanted
	 * @param y the vertical position wanted
	 * @param width the number of place to take in width
	 * @param height the number of place to take in height
	 */
	private void addWithConstrains(Container container, Component component, 
		    																int x, int y, int width, int height) {
		Insets insets = new Insets (2, 2, 2, 2);
		GridBagConstraints gbc = new GridBagConstraints();
		    	
		gbc.gridx = x; gbc.gridy = y;
		gbc.gridwidth = width; gbc.gridheight = height;
		gbc.fill = GridBagConstraints.NONE; 
		gbc.anchor = GridBagConstraints.CENTER;
		gbc.weightx = 1.0; gbc.weighty = 1.0;
		gbc.ipadx = 0; gbc.ipady = 0;
		gbc.insets = insets;
		
		LayoutManager lm = container.getLayout();
		((GridBagLayout) lm).setConstraints(component, gbc);
		container.add(component);
	}

	/**
	 * Listerner used to destroy this ServerFrameAbout object.
	 */
  public class ListOK implements ActionListener {
    public void actionPerformed(ActionEvent event) {     	
			dispose();	
    }
  }
}