package client;

import java.io.*;

/**
* The ClientGO class represents a GO-Functions.
*/
public class ClientGO implements Serializable {
	private int GOCode;
	private String term;
	private char type;
	private String GOpep;
	
	/**
	 * Construct a new Go-Functions object.
	 * @param GOCode the GO id
	 * @param term the GO term name
	 * @param type the type of the Go-Function
	 * @param GOpep the Gopep access number
	 */
	public ClientGO(int GOCode, String term, char type, String GOpep) {		
		this.GOCode = GOCode;
		this.term = term;	
		this.type = type;
		this.GOpep = GOpep;
	}
	
	/**
	 * Get the Go-Function code.
	 * @return the code of this Go-Function
	 */
	public int getGOCode() {
	  return this.GOCode;
	}
	
	/**
	 * Get the Go-Function term name.
	 * @return the term name of this Go-Function
	 */
	public String getGOTerm() {
	  return this.term;
	}
	
	/**
	 * Get the Go-Function type.
	 * @return the type of this Go-Function
	 */
	public char getGOType() {
	  return this.type;
	}
	
	/**
	 * Get the Gopep access number.
	 * @return the access number of this Go-Function.
	 */
	public String getGOpep() {
	  return this.GOpep;
	}
	
	/**
	 * Get in a string the representation of the content of this Go-Function.
	 * @return the representation of the content of the Go-Function
	 */
	public String toString() {
		String ret = " GO -> ";
		ret += " GO Code : "+GOCode+  " ";
		ret += ", Term : "+term+      " ";
		ret += ", Type : "+type+      " ";
		ret += ", GOpep : "+GOpep+    " ";
		return ret;
	}
}
	  
	  
	  
	  
	  
	  